(function () {
    "use strict";

    angular.module('pos').controller('relatorioTop10DeProdutoController', controller);
    controller.$inject = ['$scope', '$window', '$state', 'relatorioService', '$timeout'];

    function controller($scope, $window, $state, relatorioService, $timeout) {
        $scope.$parent.initializeLayout('Relatório');

        $scope.printPdf = function (showDetails) {
            $timeout(function () {
                window.print();
            }, 2000);
        };

        $scope.state = {
            produtos: {
                chart: { data: [], carregando: false, vazio: true },
                report: { data: [], carregando: false, vazio: true },
                totais: { quantidade: 0, representatividade: 0 },
                filtro: {},
            },
        }

        function getDateWithoutTime(date) {
            var dateObj = new Date(date);
            var dateWithoutTime = dateObj.toLocaleDateString();

            return dateWithoutTime;
        }

        $scope.initialize = function () {
            $scope.clearFilter();
        };
        $scope.historyBack = function () {
            $window.history.back();
        };

        $scope.getProdutos = function () {
            
            $scope.state.produtos.report.carregando = true;
            $scope.state.produtos.report.vazio = false;
            relatorioService
                .getTopNProdutos($scope.state.produtos.filtro)
                .then(
                    function (response) {
                        if (response.Status < 0) {
                            $scope.$parent.toastr.error(response.Message, 'Serviço');
                            console.error(response.Exception);
                        }
                        else {
                            angular.copy(angular.fromJson(response.Data), $scope.state.produtos.report.data);
                            $scope.state.produtos.report.vazio = (!response.Data || response.Data.length == 0);
                        }
                        $scope.totalizar(response.Data);
                        $scope.state.produtos.report.carregando = false;
                    },
                    function (error) {
                        $scope.$parent.toastr.error('Ao carregar o gráfico.', 'Comunicação com o servidor');
                        console.error(error);
                        $scope.state.produtos.report.carregando = false;
                    }
                );
        };
        $scope.totalizar = function (data) {
            $scope.state.produtos.totais.valor = 0
            $scope.state.produtos.totais.quantidade = 0;
            $scope.state.produtos.totais.representatividade = 0;

            if (!data)
                return;

            for (var i = 0; i < data.length; i++) {
                $scope.state.produtos.totais.valor += data[i].Valor;
                $scope.state.produtos.totais.quantidade += data[i].Quantidade;
                $scope.state.produtos.totais.representatividade += data[i].Representatividade;
            }
        }

        $scope.toggleFilter = function () {
            $scope.state.produtos.filtro.ativo = !$scope.state.produtos.filtro.ativo;
        };
        $scope.clearFilter = function () {
            $scope.state.produtos.filtro = {
                take: 10,
                emissao: {
                    de: new Date((new Date()).getFullYear(), 0, 1), //primeiro dia do ano
                    ate: null
                },
                codigoTerminal: '',
                periodoFechamento: '',
                codigoVendedor: '',
                ativo: false,
            }

            if ($scope.$parent.config.VisualizaVendasDia) {
                $scope.state.produtos.filtro.emissao.de = new Date();
            }
            $scope.refresh();
        };

        $scope.refresh = function () {

            if ($scope.state.produtos.filtro.emissao.de) {
                var emissaoDe = $scope.state.produtos.filtro.emissao.de;
                var emissaoDeNoTime = getDateWithoutTime(emissaoDe);
                $scope.state.produtos.filtro.emissao.de = emissaoDeNoTime;
            }

            if ($scope.state.produtos.filtro.emissao.ate) {
                var emissaoAte = $scope.state.produtos.filtro.emissao.ate;
                var emissaoAteNoTime = getDateWithoutTime(emissaoAte);
                $scope.state.produtos.filtro.emissao.ate = emissaoAteNoTime;
            }

            $scope.getProdutos();
        };

        $scope.initialize();

    }

})();